#include "globals.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <string>

#ifdef WIN32
#include <windows.h>
#endif

volatile bool stopped;
#ifdef W32GUI
HINSTANCE inst;
HANDLE wkthread;
volatile HWND mainwnd;
CRITICAL_SECTION mainwnd_cs;
#endif

extern std::string temp_path;

char *MakeTempName ()
{ char namebuf[27];
  const char *tempdir;
  char *buffer;
  static int counter = 0;

  if (temp_path.size () > 0) tempdir = temp_path.c_str ();
  else
  {
#ifdef WIN32
    tempdir = getenv ("TEMP");
    if (tempdir == NULL) tempdir = DefaultTempDir;
    sprintf (&(namebuf[0]),"%08x_%08x_%08x",GetCurrentProcessId (),time (NULL),counter);
#else
    tempdir = DefaultTempDir;
    sprintf (&(namebuf[0]),"%08x_%08x_%08x",getpid (),time (NULL),counter);
#endif
  }
  buffer = (char *)malloc (strlen (tempdir)+32);
  sprintf (buffer,"%s%c%s.tmp",tempdir,PathDivider,&(namebuf[0]));
  counter++;
  return buffer;
}
