class iptraffic_raw
{ public:
   int4 slink_id;
   int4 srcaddr;
   int4 dstaddr;
   int4 nexthop;
   int4 input;
   int4 output;
   int4 dPkts;
   int4 dOctets;
   int4 First;
   int4 Last;
   int4 srcport;
   int4 dstport;
   int4 pad;
   int4 tcp_flags;
   int4 prot;
   int4 tos;
   int4 src_as;
   int4 dst_as;
   int4 src_mask;
   int4 dst_mask;
   int4 t_class;
   int4 account_id;
   int4 timestamp;

   TYPE_DESCRIPTOR((FIELD(slink_id),
                    FIELD(srcaddr),
                    FIELD(dstaddr),
                    FIELD(nexthop),
                    FIELD(input),
                    FIELD(output),
                    FIELD(dPkts),
                    FIELD(dOctets),
                    FIELD(First),
                    FIELD(Last),
                    FIELD(srcport),
                    FIELD(dstport),
                    FIELD(pad),
                    FIELD(tcp_flags),
                    FIELD(prot),
                    FIELD(tos),
                    FIELD(src_as),
                    FIELD(dst_as),
                    FIELD(src_mask),
                    FIELD(dst_mask),
                    FIELD(t_class),
                    FIELD(account_id),
                    FIELD(timestamp)));

};

class iptraffic_raw_utm
{ public:
   int something1; // always 1
   int sourceaddr;
   int destaddr;
   int nexthop; // 0
   int something2; // 0x200
   int packets;
   int octets;
   int first;
   int last;
   unsigned short src_port;
   unsigned short dest_port;
   unsigned short tcp_flags;
   unsigned char proto;
   unsigned char tos;
   unsigned short something3;
   unsigned short src_as;
   unsigned short dst_as;
   unsigned short something4; // 0x7C34
   int slink_id;
   int account_id;
   int sourceaddr1;
   int t_class; // 0x3F2, 0x3EE
   int timestamp;
   int nfgen_addr;
   class ioerror
   { public:
      int code;
      ioerror () { code = 0; }
      ioerror (int _code) { code = _code; }
      ~ioerror () {};
   };
   iptraffic_raw_utm ();
   virtual ~iptraffic_raw_utm ();
   void Load (FILE *data);
};

class UTMRawBaseQuery
{ public:
   UTMRawBaseQuery ();
   UTMRawBaseQuery (std::string& datapath);
   UTMRawBaseQuery (char const *datapath);
   virtual ~UTMRawBaseQuery ();
   virtual void Execute ();
   virtual void ShowProgress (int state,char const *currfile,int currfile_num,int total_files);
   virtual int Filter (iptraffic_raw_utm& trec);
   virtual int ProcessRecord (iptraffic_raw_utm& trec);
   void SetTimeRange (int r_low,int r_high);
  protected:
   std::string path;
   int rows_count;
  private:
   int range_low,range_high;
};

class UTMGBBaseQuery
{ public:
   UTMGBBaseQuery ();
   UTMGBBaseQuery (std::string& gbpath);
   UTMGBBaseQuery (char const *gbpath);
   virtual ~UTMGBBaseQuery ();
   virtual void Execute ();
   virtual void ShowProgress (int state,char const *currdb,int currdb_num,int total_dbs);
   virtual int Filter (dbCursor<iptraffic_raw> &tdc);
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
   void SetTimeRange (int r_low,int r_high);
  protected:
   std::string path;
   int rows_count;
  private:
   int range_low,range_high;
};

class UTMRawToGB : public UTMRawBaseQuery
{ public:
   UTMRawToGB ();
   UTMRawToGB (std::string& datapath,std::string& _db_to_name);
   UTMRawToGB (std::string& datapath,char const *_db_to_name);
   UTMRawToGB (char const *datapath,std::string& _db_to_name);
   UTMRawToGB (char const *datapath,char const *_db_to_name);
   virtual ~UTMRawToGB ();
   virtual void Execute ();
   virtual int ProcessRecord (iptraffic_raw_utm& trec);
  protected:
   std::string db_to_name;
   int commitcounter;
   dbDatabase *db_to;
};

class UTMGBToGB : public UTMGBBaseQuery
{ public:
   UTMGBToGB ();
   UTMGBToGB (std::string& gbpath,std::string& _db_to_name);
   UTMGBToGB (std::string& gbpath,char const *_db_to_name);
   UTMGBToGB (char const *gbpath,std::string& _db_to_name);
   UTMGBToGB (char const *gbpath,char const *_db_to_name);
   virtual ~UTMGBToGB ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
  protected:
   std::string db_to_name;
   int commitcounter;
   dbDatabase *db_to;
};

class GBBaseQuery
{ public:
   GBBaseQuery ();
   GBBaseQuery (std::string& _db_from_name);
   GBBaseQuery (char const *_db_from_name);
   virtual ~GBBaseQuery ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
   void SetFilter (std::string& filtertext);
   void SetFilter (char const *filtertext);
  protected:
   std::string db_from_name;
   int rows_count;
  private:
   std::string filter;
};

class GBToGB : public GBBaseQuery
{ public:
   GBToGB ();
   GBToGB (std::string& _db_from_name,std::string& _db_to_name);
   GBToGB (std::string& _db_from_name,char const *_db_to_name);
   GBToGB (char const *_db_from_name,std::string& _db_to_name);
   GBToGB (char const *_db_from_name,char const *_db_to_name);
   virtual ~GBToGB ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
  protected:
   std::string db_from_name;
   std::string db_to_name;
   int commitcounter;
   dbDatabase *db_to;
};

class GBToGBTimeAggregator : public GBToGB
{ public:
   GBToGBTimeAggregator ();
   GBToGBTimeAggregator (std::string& _db_from_name,std::string& _db_to_name);
   GBToGBTimeAggregator (std::string& _db_from_name,char const *_db_to_name);
   GBToGBTimeAggregator (char const *_db_from_name,std::string& _db_to_name);
   GBToGBTimeAggregator (char const *_db_from_name,char const *_db_to_name);
   virtual ~GBToGBTimeAggregator ();
   virtual void Execute ();
   virtual void InitAggRanges ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
  protected:
   std::vector<int> lowts;
   std::vector<int> hights;
};

class GBToGBDataAggregator : public GBToGB
{ public:
   GBToGBDataAggregator ();
   GBToGBDataAggregator (std::string& _db_from_name,std::string& _db_to_name);
   GBToGBDataAggregator (std::string& _db_from_name,char const *_db_to_name);
   GBToGBDataAggregator (char const *_db_from_name,std::string& _db_to_name);
   GBToGBDataAggregator (char const *_db_from_name,char const *_db_to_name);
   virtual ~GBToGBDataAggregator ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
   virtual void InitAggBuffer ();
   virtual void FlushAggBuffer ();
   virtual void CopyRowToAggBuffer (dbCursor<iptraffic_raw> &tdc);
   virtual int CheckRow (dbCursor<iptraffic_raw> &tdc);
   virtual void Summarize (dbCursor<iptraffic_raw> &tdc);
  protected:
   iptraffic_raw aggbuf;
   char emptybuf;
};
