#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <signal.h>
#ifdef WIN32
#include <windows.h>
#include <io.h>
#else
#include <sys/types.h>
#include <unistd.h>
#define _unlink unlink
#endif
#include "gigabase.h"

USE_GIGABASE_NAMESPACE

#include <vector>
#include <string>
#include "utm_cl.h"
#include "globals.h"
#include "params.h"

void sigint_handler (int sig)
{ stopped = true;
}

void ProtoName (int prot,char *buffer)
{ int j = 0;

  while (proto_table[j].proto_number != -1)
  { if (prot == proto_table[j].proto_number)
    { strcpy (buffer,proto_table[j].proto_text);
      return;
    }
    j++;
  }
  strcpy (buffer,"");
}

class MyUTMGBToGB : public UTMGBToGB
{ public:
   MyUTMGBToGB () : UTMGBToGB () {}
   MyUTMGBToGB (std::string& gbpath,std::string& _db_to_name) : UTMGBToGB (gbpath,_db_to_name) {}
   MyUTMGBToGB (std::string& gbpath,const char *_db_to_name) : UTMGBToGB (gbpath,_db_to_name) {}
   MyUTMGBToGB (const char *gbpath,std::string& _db_to_name) : UTMGBToGB (gbpath,_db_to_name) {}
   MyUTMGBToGB (const char *gbpath,const char *_db_to_name) : UTMGBToGB (gbpath,_db_to_name) {}
   virtual ~MyUTMGBToGB ();
   virtual int Filter (dbCursor<iptraffic_raw> &tdc);
   virtual void ShowProgress (int state,const char *currdb_name,int currdb_num,int total_dbs);
};

class MyUTMRawToGB : public UTMRawToGB
{ public:
   MyUTMRawToGB () : UTMRawToGB () {}
   MyUTMRawToGB (std::string& datapath,std::string& _db_to_name) : UTMRawToGB (datapath,_db_to_name) {}
   MyUTMRawToGB (std::string& datapath,const char *_db_to_name) : UTMRawToGB (datapath,_db_to_name) {}
   MyUTMRawToGB (const char *datapath,std::string& _db_to_name) : UTMRawToGB (datapath,_db_to_name) {}
   MyUTMRawToGB (const char *datapath,const char *_db_to_name) : UTMRawToGB (datapath,_db_to_name) {}
   virtual ~MyUTMRawToGB ();
   virtual int Filter (iptraffic_raw_utm& trec);
   virtual void ShowProgress (int state,const char *currdb_name,int currdb_num,int total_dbs);
};

class MySinglePeriodAggregator : public GBToGBTimeAggregator
{ public:
   MySinglePeriodAggregator () : GBToGBTimeAggregator () {}
   MySinglePeriodAggregator (std::string& _db_from_name,std::string& _db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MySinglePeriodAggregator (std::string& _db_from_name,char const *_db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MySinglePeriodAggregator (char const *_db_from_name,std::string& _db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MySinglePeriodAggregator (char const *_db_from_name,char const *_db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   virtual ~MySinglePeriodAggregator ();
   virtual void Execute ();
   virtual void InitAggRanges ();
};

class MyMultiplePeriodAggregator : public GBToGBTimeAggregator
{ public:
   MyMultiplePeriodAggregator () : GBToGBTimeAggregator () {}
   MyMultiplePeriodAggregator (std::string& _db_from_name,std::string& _db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MyMultiplePeriodAggregator (std::string& _db_from_name,char const *_db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MyMultiplePeriodAggregator (char const *_db_from_name,std::string& _db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   MyMultiplePeriodAggregator (char const *_db_from_name,char const *_db_to_name) : GBToGBTimeAggregator (_db_from_name,_db_to_name) {}
   virtual ~MyMultiplePeriodAggregator ();
   virtual void Execute ();
   virtual void InitAggRanges ();
};

class MyDataAggregator : public GBToGBDataAggregator
{ public:
   MyDataAggregator () : GBToGBDataAggregator () {}
   MyDataAggregator (std::string& _db_from_name,std::string& _db_to_name) : GBToGBDataAggregator (_db_from_name,_db_to_name) {}
   MyDataAggregator (std::string& _db_from_name,char const *_db_to_name) : GBToGBDataAggregator (_db_from_name,_db_to_name) {}
   MyDataAggregator (char const *_db_from_name,std::string& _db_to_name) : GBToGBDataAggregator (_db_from_name,_db_to_name) {}
   MyDataAggregator (char const *_db_from_name,char const *_db_to_name) : GBToGBDataAggregator (_db_from_name,_db_to_name) {}
   virtual ~MyDataAggregator ();
   virtual void Execute ();
   virtual void CopyRowToAggBuffer (dbCursor<iptraffic_raw> &tdc);
   virtual int CheckRow (dbCursor<iptraffic_raw> &tdc);
   virtual void Summarize (dbCursor<iptraffic_raw> &tdc);
   virtual void FlushAggBuffer ();
};

class GBToCSV : public GBBaseQuery
{ public:
   GBToCSV () : GBBaseQuery () { trafsum = 0; }
   GBToCSV (std::string& _db_from_name) : GBBaseQuery (_db_from_name) { trafsum = 0; }
   GBToCSV (char const *_db_from_name) : GBBaseQuery (_db_from_name) { trafsum = 0; }
   virtual ~GBToCSV ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
  protected:
   double trafsum;
};

class GBToStdout : public GBBaseQuery
{ public:
   GBToStdout () : GBBaseQuery () {}
   GBToStdout (std::string& _db_from_name) : GBBaseQuery (_db_from_name) {}
   GBToStdout (char const *_db_from_name) : GBBaseQuery (_db_from_name) {}
   virtual ~GBToStdout ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
};

#define MAX_ROWS_IN_BLOCK 1000

class GBToMySQL : public GBBaseQuery
{ public:
   GBToMySQL () : GBBaseQuery () { rows_all = rows_in_block = 0; }
   GBToMySQL (std::string& _db_from_name) : GBBaseQuery (_db_from_name) { rows_all = rows_in_block = 0; }
   GBToMySQL (char const *_db_from_name) : GBBaseQuery (_db_from_name) { rows_all = rows_in_block = 0; }
   virtual ~GBToMySQL ();
   virtual void Execute ();
   virtual int ProcessRow (dbCursor<iptraffic_raw> &tdc);
  protected:
   int rows_all;
   int rows_in_block;
};

MyUTMGBToGB::~MyUTMGBToGB ()
{}

int MyUTMGBToGB::Filter (dbCursor<iptraffic_raw> &tdc)
{ int res,t_res;

  res = UTMGBToGB::Filter (tdc);
  if (res)
  { switch (class_filter)
    { case 1:
       t_res = 0;
       for (int j = 0;j < incoming_classes.size ();j++)
       { t_res |= (tdc->t_class == incoming_classes[j]);
         if (t_res) break;
       }
       break;
      case 2:
       t_res = 0;
       for (int j = 0;j < outgoing_classes.size ();j++)
       { t_res |= (tdc->t_class == outgoing_classes[j]);
         if (t_res) break;
       }
       break;
      case 3:
       t_res = 0;
       for (int j = 0;j < paid_classes.size ();j++)
       { t_res |= (tdc->t_class == paid_classes[j]);
         if (t_res) break;
       }
       break;
      default:
       t_res = 1;
       break;
    }
    res &= t_res;
    if (!account_id.IsEmpty ()) res &= (tdc->account_id == account_id.Value ());
    if (!slink_id.IsEmpty ()) res &= (tdc->slink_id == slink_id.Value ());
    if (!source_addr.IsEmpty ()) res &= (tdc->srcaddr == source_addr.Value ());
    if (!dest_addr.IsEmpty ()) res &= (tdc->dstaddr == dest_addr.Value ());
    if (!source_port.IsEmpty ()) res &= (tdc->srcport == source_port.Value ());
    if (!dest_port.IsEmpty ()) res &= (tdc->dstport == dest_port.Value ());
    if (!proto.IsEmpty ()) res &= (tdc->prot == proto.Value ());
  }
  return res;
}

void MyUTMGBToGB::ShowProgress (int state,const char *currdb_name,int currdb_num,int total_dbs)
{ int percentage;

  switch (state)
  { case 0:
     if (!quiet)
     { printf (CollectingDataDBSMsg);
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    case 1:
     if (!quiet)
     { if (currdb_num == 0) percentage = (total_dbs == 0)?100:0;
       else
       { if (currdb_num >= total_dbs) percentage = 100;
         else
         { if (total_dbs < 10000) percentage = (currdb_num * 100) / ((total_dbs * 100) / 100);
           else percentage = currdb_num / (total_dbs / 100);
         }
       }
       printf ("\b\b\b\b%3d%%",percentage);
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    case 2:
     if (!quiet)
     { printf ("\b\b\b\b    \n");
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    default:
     break;
  }
}

MyUTMRawToGB::~MyUTMRawToGB ()
{}

int MyUTMRawToGB::Filter (iptraffic_raw_utm& trec)
{ int res,t_res;

  res = UTMRawToGB::Filter (trec);
  if (res)
  { switch (class_filter)
    { case 1:
       t_res = 0;
       for (int j = 0;j < incoming_classes.size ();j++)
       { t_res |= (trec.t_class == incoming_classes[j]);
         if (t_res) break;
       }
       break;
      case 2:
       t_res = 0;
       for (int j = 0;j < outgoing_classes.size ();j++)
       { t_res |= (trec.t_class == outgoing_classes[j]);
         if (t_res) break;
       }
       break;
      case 3:
       t_res = 0;
       for (int j = 0;j < paid_classes.size ();j++)
       { t_res |= (trec.t_class == paid_classes[j]);
         if (t_res) break;
       }
       break;
      default:
       t_res = 1;
       break;
    }
    res &= t_res;
    if (!account_id.IsEmpty ()) res &= (trec.account_id == account_id.Value ());
    if (!slink_id.IsEmpty ()) res &= (trec.slink_id == slink_id.Value ());
    if (!source_addr.IsEmpty ()) res &= (trec.sourceaddr == source_addr.Value ());
    if (!dest_addr.IsEmpty ()) res &= (trec.destaddr == dest_addr.Value ());
    if (!source_port.IsEmpty ()) res &= (trec.src_port == source_port.Value ());
    if (!dest_port.IsEmpty ()) res &= (trec.dest_port == dest_port.Value ());
    if (!proto.IsEmpty ()) res &= (trec.proto == proto.Value ());
  }
  return res;
}

void MyUTMRawToGB::ShowProgress (int state,const char *currdb_name,int currdb_num,int total_dbs)
{ int percentage;

  switch (state)
  { case 0:
     if (!quiet)
     { printf (CollectingDataUTMMsg);
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    case 1:
     if (!quiet)
     { if (currdb_num == 0) percentage = (total_dbs == 0)?100:0;
       else
       { if (currdb_num >= total_dbs) percentage = 100;
         else
         { if (total_dbs < 10000) percentage = (currdb_num * 100) / ((total_dbs * 100) / 100);
           else percentage = currdb_num / (total_dbs / 100);
         }
       }
       printf ("\b\b\b\b%3d%%",percentage);
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    case 2:
     if (!quiet)
     { printf ("\b\b\b\b    \n");
#ifndef WIN32
       fflush (stdout);
#endif
     }
     break;
    default:
     break;
  }
}

MySinglePeriodAggregator::~MySinglePeriodAggregator ()
{}

void MySinglePeriodAggregator::Execute ()
{ SetFilter ("order by timestamp asc");
  GBToGBTimeAggregator::Execute ();
}

void MySinglePeriodAggregator::InitAggRanges ()
{ int low,high;

  if (period_begin.Value () < period_end.Value ())
  { low = period_begin.Value ();
    high = period_end.Value ();
  }
  else
  { low = period_end.Value ();
    high = period_begin.Value ();
  }
  this->lowts.insert (this->lowts.end (),low);
  this->hights.insert (this->hights.end (),high);
}

MyMultiplePeriodAggregator::~MyMultiplePeriodAggregator ()
{}

void MyMultiplePeriodAggregator::Execute ()
{ SetFilter ("order by timestamp asc");
  GBToGBTimeAggregator::Execute ();
}

void MyMultiplePeriodAggregator::InitAggRanges ()
{ int j,low,high,ts;

  ts = period_begin.Value ();
  do
  { low = ts - (ts % 3600);
    high = ts + 3600 * agg_step;
    this->lowts.insert (this->lowts.end (),low);
    this->hights.insert (this->hights.end (),high);
    ts = high;
  }
  while (high < period_end.Value ());
}

MyDataAggregator::~MyDataAggregator ()
{}

void MyDataAggregator::Execute ()
{ SetFilter ((!account_id.IsEmpty ())?
             "order by timestamp,srcaddr,dstaddr asc":
             "order by timestamp,account_id,srcaddr,dstaddr asc");
  GBToGBDataAggregator::Execute ();
}

void MyDataAggregator::CopyRowToAggBuffer (dbCursor<iptraffic_raw> &tdc)
{ this->aggbuf.timestamp = tdc->timestamp;
  this->aggbuf.srcaddr = tdc->srcaddr;
  this->aggbuf.dstaddr = tdc->dstaddr;
  this->aggbuf.dOctets = tdc->dOctets;
  if (account_id.IsEmpty ()) this->aggbuf.account_id = tdc->account_id;
}

int MyDataAggregator::CheckRow (dbCursor<iptraffic_raw> &tdc)
{ int res;

  res = ((tdc->timestamp == this->aggbuf.timestamp) &&
         (tdc->srcaddr == this->aggbuf.srcaddr) &&
         (tdc->dstaddr == this->aggbuf.dstaddr));
  if (account_id.IsEmpty ()) res &= (tdc->account_id == this->aggbuf.account_id);
  return res;
}

void MyDataAggregator::Summarize (dbCursor<iptraffic_raw> &tdc)
{ this->aggbuf.dOctets += tdc->dOctets;
}

void MyDataAggregator::FlushAggBuffer ()
{ this->db_to->insert (this->aggbuf);
  this->commitcounter++;
  if (this->commitcounter == 10000)
  { this->db_to->commit ();
    this->commitcounter = 0;
  }
}

GBToCSV::~GBToCSV ()
{}

static void FormatValue (double value,char *buffer)
{ int j;

  switch (unit)
  { case 3:
     sprintf (buffer,"%.6f",(double)(value / 1048576));
     break;
    case 2:
     sprintf (buffer,"%.3f",(double)(value / 1024));
     break;
    default:
     sprintf (buffer,"%.0f",(double)value);
     break;
  }
  j = 0;
  while (buffer[j] != 0)
  { if (buffer[j] == '.')
    { buffer[j] = ',';
      break;
    }
    j++;
  }
}

void GBToCSV::Execute ()
{ char datebuf[20];
  time_t ts;
  char *buffer;

  if (!period_begin.IsEmpty ())
  { ts = period_begin.Value ();
    strftime (&(datebuf[0]),20,"%d.%m.%Y %H:%M:%S",localtime (&ts));
    fprintf (outfile,"\" \";\"%s\"",&(datebuf[0]));
    fprintf (outfile,(report_type == 1)?
                   ";;;;;;":
                   (report_type == 2)?
                   ";;":
                   ";");
    if (account_id.IsEmpty ()) fprintf (outfile,";");
    fprintf (outfile,"\n");
  }
  if (!period_end.IsEmpty ())
  { ts = period_end.Value ();
    strftime (&(datebuf[0]),20,"%d.%m.%Y %H:%M:%S",localtime (&ts));
    fprintf (outfile,"\" \";\"%s\"",&(datebuf[0]));
    fprintf (outfile,(report_type == 1)?
                   ";;;;;;":
                   (report_type == 2)?
                   ";;":
                   ";");
    if (account_id.IsEmpty ()) fprintf (outfile,";");
    fprintf (outfile,"\n");
  }
  fprintf (outfile,(report_type == 1)?
                   ";;;;;;;":
                   (report_type == 2)?
                   ";;;":
                   ";;");
  if (account_id.IsEmpty ()) fprintf (outfile,";");
  fprintf (outfile,"\n");
  fprintf (outfile,(report_type == 1)?
                   "\"\";"
                   "\"\";"
                   "\"\";"
                   "\"\";"
                   "\" \";"
                   "\" \";"
                   "\" \";"
                   "\" \"":
                   (report_type == 2)?
                   "\"\";"
                   "\"\";"
                   "\"\";"
                   "\" \"":
                   "\"\";"
                   "\"\";"
                   "\" \"");
  if (account_id.IsEmpty ()) fprintf (outfile,";\" \"");
  fprintf (outfile,"\n");
  this->trafsum = 0;
  GBBaseQuery::Execute ();
  fprintf (outfile,(report_type == 1)?
                   ";;;;;;;":
                   (report_type == 2)?
                   ";;;":
                   ";;");
  if (account_id.IsEmpty ()) fprintf (outfile,";");
  fprintf (outfile,"\n");
  buffer = (char *)malloc (512);
  FormatValue (this->trafsum,buffer);
  fprintf (outfile,(report_type == 1)?
                   "\"\";;;;;;%s;":
                   (report_type == 2)?
                   "\"\";;;%s":
                   "\"\";;%s",buffer);
  if (account_id.IsEmpty ()) fprintf (outfile,";");
  fprintf (outfile,"\n");
  free (buffer);
}

int GBToCSV::ProcessRow (dbCursor<iptraffic_raw> &tdc)
{ char datebuf[20];
  char protobuf[10];
  time_t ts;
  int proto;
  char *buffer;

  if (stopped) return 0;
  buffer = (char *)malloc (512);
  if (report_type == 1)
  { ts = tdc->timestamp;
    strftime (&(datebuf[0]),20,"%d.%m.%Y %H:%M:%S",localtime (&ts));
    proto = tdc->prot;
    ProtoName (proto,&(protobuf[0]));
    if (protobuf[0] == 0) sprintf (&(protobuf[0]),"%d",proto);
    FormatValue ((double)(tdc->dOctets),buffer);
    fprintf (outfile,"\"%s\";\"%d.%d.%d.%d\";\"%d.%d.%d.%d\";\"%s\";%d;%d;%s;%d",
                     &datebuf,
                     (((tdc->srcaddr) >> 24) & 0xFF),
                     (((tdc->srcaddr) >> 16) & 0xFF),
                     (((tdc->srcaddr) >> 8) & 0xFF),
                     ((tdc->srcaddr) & 0xFF),
                     (((tdc->dstaddr) >> 24) & 0xFF),
                     (((tdc->dstaddr) >> 16) & 0xFF),
                     (((tdc->dstaddr) >> 8) & 0xFF),
                     ((tdc->dstaddr) & 0xFF),
                     &protobuf,
                     tdc->srcport,
                     tdc->dstport,
                     buffer,
                     tdc->t_class);
  }
  else
  { if (report_type == 2)
    { ts = tdc->timestamp;
      strftime (&(datebuf[0]),20,"%d.%m.%Y %H:%M:%S",localtime (&ts));
      FormatValue ((double)(tdc->dOctets),buffer);
      fprintf (outfile,"\"%s\";\"%d.%d.%d.%d\";\"%d.%d.%d.%d\";%s",
                       &datebuf,
                       (((tdc->srcaddr) >> 24) & 0xFF),
                       (((tdc->srcaddr) >> 16) & 0xFF),
                       (((tdc->srcaddr) >> 8) & 0xFF),
                       ((tdc->srcaddr) & 0xFF),
                       (((tdc->dstaddr) >> 24) & 0xFF),
                       (((tdc->dstaddr) >> 16) & 0xFF),
                       (((tdc->dstaddr) >> 8) & 0xFF),
                       ((tdc->dstaddr) & 0xFF),
                       buffer);
    }
    else
    { FormatValue ((double)(tdc->dOctets),buffer);
      fprintf (outfile,"\"%d.%d.%d.%d\";\"%d.%d.%d.%d\";%s",
                       (((tdc->srcaddr) >> 24) & 0xFF),
                       (((tdc->srcaddr) >> 16) & 0xFF),
                       (((tdc->srcaddr) >> 8) & 0xFF),
                       ((tdc->srcaddr) & 0xFF),
                       (((tdc->dstaddr) >> 24) & 0xFF),
                       (((tdc->dstaddr) >> 16) & 0xFF),
                       (((tdc->dstaddr) >> 8) & 0xFF),
                       ((tdc->dstaddr) & 0xFF),
                       buffer);
    }
  }
  if (account_id.IsEmpty ()) fprintf (outfile,";%d",tdc->account_id);
  fprintf (outfile,"\n");
  this->trafsum += tdc->dOctets;
  free (buffer);
  return 1;
}

GBToStdout::~GBToStdout ()
{}

int GBToStdout::ProcessRow (dbCursor<iptraffic_raw> &tdc)
{ if (stopped) return 0;
  fprintf (outfile,"%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\t%d\n",
                   tdc->timestamp,
                   tdc->srcaddr,
                   tdc->dstaddr,
                   tdc->srcport,
                   tdc->dstport,
                   tdc->dPkts,
                   tdc->dOctets,
                   tdc->prot,
                   tdc->tos,
                   tdc->tcp_flags,
                   tdc->t_class,
                   tdc->account_id,
                   tdc->slink_id);
  return 1;
}

GBToMySQL::~GBToMySQL ()
{}

void GBToMySQL::Execute ()
{ fprintf (outfile,"CREATE TABLE IF NOT EXISTS iptraffic_raw "
                   "(slink_id INT,"
                   "srcaddr INT,"
                   "dstaddr INT,"
                   "nexthop INT,"
                   "input INT,"
                   "output INT,"
                   "dPkts INT,"
                   "dOctets INT,"
                   "First INT,"
                   "Last INT,"
                   "srcport INT,"
                   "dstport INT,"
                   "pad INT,"
                   "tcp_flags INT,"
                   "prot INT,"
                   "tos INT,"
                   "src_as INT,"
                   "dst_as INT,"
                   "src_mask INT,"
                   "dst_mask INT,"
                   "t_class INT,"
                   "account_id INT,"
                   "timestamp INT);\n");
  GBBaseQuery::Execute ();
}

int GBToMySQL::ProcessRow (dbCursor<iptraffic_raw> &tdc)
{ if (stopped) return 0;
  if (this->rows_all == 0) this->rows_all = this->rows_count;
  if (this->rows_in_block == 0) fprintf (outfile,"INSERT INTO iptraffic_raw VALUES ");
  fprintf (outfile,"(%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d)",
           tdc->slink_id,
           tdc->srcaddr,
           tdc->dstaddr,
           tdc->nexthop,
           tdc->input,
           tdc->output,
           tdc->dPkts,
           tdc->dOctets,
           tdc->First,
           tdc->Last,
           tdc->srcport,
           tdc->dstport,
           tdc->pad,
           tdc->tcp_flags,
           tdc->prot,
           tdc->tos,
           tdc->src_as,
           tdc->dst_as,
           tdc->src_mask,
           tdc->dst_mask,
           tdc->t_class,
           tdc->account_id,
           tdc->timestamp);
  this->rows_in_block++;
  this->rows_all--;
  fprintf (outfile,((rows_in_block == MAX_ROWS_IN_BLOCK) || (rows_all == 0))?";\n":",");
  if ((rows_in_block == MAX_ROWS_IN_BLOCK) || (rows_all == 0)) rows_in_block = 0;
  return 1;
}

int main (int _argc,char **_argv,char **_envp)
{ char *tempdbname1, *tempdbname2, *tempdbname3;
  UTMGBBaseQuery *engine1;
  UTMRawBaseQuery *engine2;
  GBBaseQuery *engine3;
  GBToGBTimeAggregator *engine4;
  GBToGBDataAggregator *engine5;

  my_argc = _argc;
  my_argv = _argv;
  LoadCmdLineFlags ();
  if (help_me)
  { printf (HelpScreen);
    return 0;
  }
  signal (SIGINT,sigint_handler);
#ifdef WIN32
  signal (SIGBREAK,sigint_handler);
#else
  signal (SIGTERM,sigint_handler);
#endif
  LoadParametersFromConfigFile ();
  LoadParameters (noi);
  if ((account_id.IsEmpty ()) &&
      (slink_id.IsEmpty ()) &&
      (source_addr.IsEmpty ()) &&
      (dest_addr.IsEmpty ()) &&
      (source_port.IsEmpty ()) &&
      (dest_port.IsEmpty ()) &&
      (proto.IsEmpty ()))
  { printf (BadFilterErrorMsg);
    return 0;
  }
  if (stopped) return 0;
  if (workmode == 0)
  { if ((report_type == 2) && (period_begin.IsEmpty () || period_end.IsEmpty ()))
    { printf (AggregationImpossibleMsg);
      return 0;
    }
    if ((report_type == 3) && (period_begin.IsEmpty ()))
    { printf (SummarizeImpossibleMsg);
      return 0;
    }
  }
  if ((!period_begin.IsEmpty ()) && (!period_end.IsEmpty ()))
  { if (period_begin.Value () > period_end.Value ())
    { int temp = period_begin.Value ();
      period_begin = period_end.Value ();
      period_end = temp;
    }
  }
  tempdbname1 = MakeTempName ();
  engine1 = new MyUTMGBToGB (dbpath,tempdbname1);
  if ((!period_begin.IsEmpty ()) && (!period_end.IsEmpty ())) engine1->SetTimeRange (period_begin.Value (),period_end.Value ());
  else
  { if (!period_begin.IsEmpty ()) engine1->SetTimeRange (period_begin.Value (),-1);
    else
     if (!period_end.IsEmpty ()) engine1->SetTimeRange (-1,period_end.Value ());
  }
  engine1->Execute ();
  delete engine1;
  if (stopped)
  { _unlink (tempdbname1);
    free (tempdbname1);
    return 0;
  }
  engine2 = new MyUTMRawToGB (dbpath,tempdbname1);
  if ((!period_begin.IsEmpty ()) && (!period_end.IsEmpty ())) engine2->SetTimeRange (period_begin.Value (),period_end.Value ());
  else
  { if (!period_begin.IsEmpty ()) engine2->SetTimeRange (period_begin.Value (),-1);
    else
     if (!period_end.IsEmpty ()) engine2->SetTimeRange (-1,period_end.Value ());
  }
  engine2->Execute ();
  delete engine2;
  if (stopped)
  { _unlink (tempdbname1);
    free (tempdbname1);
    return 0;
  }
  if ((workmode == 0) && (to_stdout)) outfile = stdout;
  else outfile = fopen (outfile_name.c_str (),"wt");
  if (outfile != NULL)
  { if (workmode == 0)
    { if (report_type != 1)
      { tempdbname2 = MakeTempName ();
        if (report_type == 2) engine4 = new MyMultiplePeriodAggregator (tempdbname1,tempdbname2);
        else engine4 = new MySinglePeriodAggregator (tempdbname1,tempdbname2);
        engine4->Execute ();
        delete engine4;
        if (stopped)
        { if (outfile != stdout)
          { fclose (outfile);
            _unlink (outfile_name.c_str ());
          }
          _unlink (tempdbname2);
          free (tempdbname2);
          _unlink (tempdbname1);
          free (tempdbname1);
          return 0;
        }
        tempdbname3 = MakeTempName ();
        engine5 = new MyDataAggregator (tempdbname2,tempdbname3);
        engine5->Execute ();
        delete engine5;
        if (stopped)
        { if (outfile != stdout)
          { fclose (outfile);
            _unlink (outfile_name.c_str ());
          }
          _unlink (tempdbname3);
          free (tempdbname3);
          _unlink (tempdbname2);
          free (tempdbname2);
          _unlink (tempdbname1);
          free (tempdbname1);
          return 0;
        }
      }
      if (!to_stdout)
       engine3 = new GBToCSV ((report_type != 1)?tempdbname3:tempdbname1);
      else
       engine3 = new GBToStdout (tempdbname1);
      engine3->SetFilter ("order by timestamp asc,dOctets desc");
    }
    else
    { if (workmode == 1)
      { engine3 = new GBToMySQL (tempdbname1);
        engine3->SetFilter ("order by timestamp asc");
      }
      else engine3 = NULL;
    }
    if (engine3 != NULL)
    { engine3->Execute ();
      delete engine3;
    }
    if (outfile != stdout) fclose (outfile);
    if (workmode == 0)
    { if (report_type != 1)
      { _unlink (tempdbname3);
        free (tempdbname3);
        _unlink (tempdbname2);
        free (tempdbname2);
      }
    }
  }
  else printf (ResultFileOpenErrorMsg);
  _unlink (tempdbname1);
  free (tempdbname1);
  return 0;
}
