#include <stdio.h>
#include <string.h>
#include <string>
#include <vector>
#include "globals.h"
#include "params.h"

proto_entry proto_table[] =
{{1,"ICMP"},{2,"IGMP"},{3,"GGP"},{4,"IPIP"},
 {6,"TCP"},{17,"UDP"},{47,"GRE"},{50,"ESP"},
 {51,"AH"},{-1,NULL}};

FILE *outfile;
IntParameter period_begin;
IntParameter period_end;
IntParameter account_id;
IntParameter slink_id;
IntParameter source_addr;
IntParameter dest_addr;
IntParameter source_port;
IntParameter dest_port;
IntParameter proto;
int my_argc;
char **my_argv;
bool quiet;
bool help_me;
bool noi;
std::string temp_path;
std::string dbpath;
std::string outfile_name;
char class_filter;
char workmode;
std::vector<int> incoming_classes;
std::vector<int> outgoing_classes;
std::vector<int> paid_classes;
bool to_stdout;
char unit;
char report_type;
int agg_step;

static int ParseDateTime (const char *tdt,int values[])
{ int j,digit_buf,digits_count,syntax_error;

  j = 0;
  while (tdt[j] != 0)
  { if (!isspace (tdt[j])) break;
    j++;
  }
  digits_count = 0;
  syntax_error = 0;
  digit_buf = 0;
  do
  { if (isdigit (tdt[j]))
    { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
      digit_buf += (tdt[j] - '0');
      digits_count++;
      if (digits_count > 2)
      { syntax_error = 1;
        break;
      }
    }
    else
    { if ((tdt[j] == '-') || (tdt[j] == '/') || (tdt[j] == '.') || (tdt[j] == 0))
      { values[0] = digit_buf;
        if (tdt[j] != 0) j++;
        break;
      }
      else
      { syntax_error = 1;
        break;
      }
    }
    j++;
  }
  while (!syntax_error);
  if (!syntax_error)
  { digit_buf = 0;
    digits_count = 0;
    do
    { if (isdigit (tdt[j]))
      { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
        digit_buf += (tdt[j] - '0');
        digits_count++;
        if (digits_count > 2)
        { syntax_error = 1;
          break;
        }
      }
      else
      { if ((tdt[j] == '-') || (tdt[j] == '/') || (tdt[j] == '.') || (tdt[j] == 0))
        { values[1] = digit_buf;
          if (tdt[j] != 0) j++;
          break;
        }
        else
        { syntax_error = 1;
          break;
        }
      }
      j++;
    }
    while (!syntax_error);
    if (!syntax_error)
    { digit_buf = 0;
      digits_count = 0;
      do
      { if (isdigit (tdt[j]))
        { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
          digit_buf += (tdt[j] - '0');
          digits_count++;
          if (digits_count > 4)
          { syntax_error = 1;
            break;
          }
        }
        else
        { if (isspace (tdt[j]) || (tdt[j] == 0))
          { if (digits_count == 2) digit_buf += 2000;
            values[2] = digit_buf;
            if (tdt[j] != 0) j++;
            break;
          }
          else
          { syntax_error = 1;
            break;
          }
        }
        j++;
      }
      while (!syntax_error);
      if (!syntax_error)
      { while (tdt[j] != 0)
        { if (!isspace (tdt[j])) break;
          j++;
        }
        digit_buf = 0;
        digits_count = 0;
        do
        { if (isdigit (tdt[j]))
          { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
            digit_buf += (tdt[j] - '0');
            digits_count++;
            if (digits_count > 2)
            { syntax_error = 1;
              break;
            }
          }
          else
          { if ((tdt[j] == ':') || (tdt[j] == 0))
            { values[3] = digit_buf;
              if (tdt[j] != 0) j++;
              break;
            }
            else
            { syntax_error = 1;
              break;
            }
          }
          j++;
        }
        while (!syntax_error);
        if (!syntax_error)
        { digit_buf = 0;
          digits_count = 0;
          do
          { if (isdigit (tdt[j]))
            { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
              digit_buf += (tdt[j] - '0');
              digits_count++;
              if (digits_count > 2)
              { syntax_error = 1;
                break;
              }
            }
            else
            { if ((tdt[j] == ':') || (tdt[j] == 0))
              { values[4] = digit_buf;
                if (tdt[j] != 0) j++;
                break;
              }
              else
              { syntax_error = 1;
                break;
              }
            }
            j++;
          }
          while (!syntax_error);
          if (!syntax_error)
          { digit_buf = 0;
            digits_count = 0;
            do
            { if (isdigit (tdt[j]))
              { if ((j != 0) && (isdigit (tdt[j-1]))) digit_buf *= 10;
                digit_buf += (tdt[j] - '0');
                digits_count++;
                if (digits_count > 2)
                { syntax_error = 1;
                  break;
                }
              }
              else
              { if (tdt[j] == 0)
                { values[5] = digit_buf;
                  break;
                }
              }
              j++;
            }
            while (!syntax_error);
          }
        }
      }
    }
  }
  return syntax_error;
}

static int IsLeapYear (int year)
{ return ((((year % 4) == 0) && ((year % 100) != 0)) || ((year % 400) == 0))?1:0;
}

static int DaysInMonth (int month,int year)
{ static int days[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
  int res;

  res = 0;
  if ((month >= 1) && (month <= 12))
  { res = days[month-1];
    if ((month == 2) && IsLeapYear (year)) res++;
  }
  return res;
}

static int IsGoodDateTime (int values[])
{ return ((values[0] >= 1) && (values[0] <= DaysInMonth (values[1],values[2])) &&
          (values[1] >= 1) && (values[1] <= 12) &&
          (values[2] >= 1970) && (values[2] <= 2037) &&
          (values[3] >= 0) && (values[3] <= 23) &&
          (values[4] >= 0) && (values[4] <= 59) &&
          (values[5] >= 0) && (values[5] <= 59));
}

static int ParseInteger (const char *ti,int *value)
{ int j,digit_buf,digits_count,syntax_error;

  j = 0;
  while (ti[j] != 0)
  { if (!isspace (ti[j])) break;
    j++;
  }
  digits_count = 0;
  syntax_error = 0;
  digit_buf = 0;
  do
  { if (isdigit (ti[j]))
    { if ((j != 0) && (isdigit (ti[j-1]))) digit_buf *= 10;
      digit_buf += (ti[j] - '0');
      digits_count++;
      if (digits_count > 10)
      { syntax_error = 1;
        break;
      }
    }
    else
    { if (isspace (ti[j]) || (ti[j] == 0))
      { *value = digit_buf;
        break;
      }
      else
      { syntax_error = 1;
        break;
      }
    }
    j++;
  }
  while (!syntax_error);
  return syntax_error;
}

static int IsGoodInteger (int value)
{ return (value >= 0);
}

static int IsGoodShort (int value)
{ return ((value >= 0) && (value <= 65535));
}

static int ParseIPAddress (const char *tip,int values[])
{ int j,digit_buf,digits_count,syntax_error;

  j = 0;
  while (tip[j] != 0)
  { if (!isspace (tip[j])) break;
    j++;
  }
  digits_count = 0;
  digit_buf = 0;
  syntax_error = 0;
  do
  { if (isdigit (tip[j]))
    { if ((j != 0) && (isdigit (tip[j-1]))) digit_buf *= 10;
      digit_buf += (tip[j] - '0');
      digits_count++;
      if (digits_count > 3)
      { syntax_error = 1;
        break;
      }
    }
    else
    { if (tip[j] == '.')
      { values[0] = digit_buf;
        j++;
        break;
      }
      else
      { syntax_error = 1;
        break;
      }
    }
    j++;
  }
  while (!syntax_error);
  if (!syntax_error)
  { digit_buf = 0;
    digits_count = 0;
    do
    { if (isdigit (tip[j]))
      { if ((j != 0) && (isdigit (tip[j-1]))) digit_buf *= 10;
        digit_buf += (tip[j] - '0');
        digits_count++;
        if (digits_count > 3)
        { syntax_error = 1;
          break;
        }
      }
      else
      { if (tip[j] == '.')
        { values[1] = digit_buf;
          j++;
          break;
        }
        else
        { syntax_error = 1;
          break;
        }
      }
      j++;
    }
    while (!syntax_error);
    if (!syntax_error)
    { digit_buf = 0;
      digits_count = 0;
      do
      { if (isdigit (tip[j]))
        { if ((j != 0) && (isdigit (tip[j-1]))) digit_buf *= 10;
          digit_buf += (tip[j] - '0');
          digits_count++;
          if (digits_count > 3)
          { syntax_error = 1;
            break;
          }
        }
        else
        { if (tip[j] == '.')
          { values[2] = digit_buf;
            j++;
            break;
          }
          else
          { syntax_error = 1;
            break;
          }
        }
        j++;
      }
      while (!syntax_error);
      if (!syntax_error)
      { digit_buf = 0;
        digits_count = 0;
        do
        { if (isdigit (tip[j]))
          { if ((j != 0) && (isdigit (tip[j-1]))) digit_buf *= 10;
            digit_buf += (tip[j] - '0');
            digits_count++;
            if (digits_count > 3)
            { syntax_error = 1;
              break;
            }
          }
          else
          { if (isspace (tip[j]) || (tip[j] == 0))
            { values[3] = digit_buf;
              break;
            }
            else
            { syntax_error = 1;
              break;
            }
          }
          j++;
        }
        while (!syntax_error);
      }
    }
  }
  return syntax_error;
}

static int IsGoodIPAddress (int values[])
{ return ((values[0] >= 0) && (values[0] <= 255) &&
          (values[1] >= 0) && (values[1] <= 255) &&
          (values[2] >= 0) && (values[2] <= 255) &&
          (values[3] >= 0) && (values[3] <= 255));
}

static int ParseProtocol (const char *tp,int *value)
{ int j,digit_buf,sym_count,syntax_error;
  char equal;

  j = 0;
  while (tp[j] != 0)
  { if (!isspace (tp[j])) break;
    j++;
  }
  digit_buf = 0;
  sym_count = 0;
  syntax_error = 0;
  if (isdigit (tp[j]))
  { do
    { if (isdigit (tp[j]))
      { if ((j != 0) && (isdigit (tp[j-1]))) digit_buf *= 10;
        digit_buf += (tp[j] - '0');
        sym_count++;
        if (sym_count > 3)
        { syntax_error = 1;
          break;
        }
      }
      else
      { if (isspace (tp[j]) || (tp[j] == 0))
        { *value = digit_buf;
          break;
        }
      }
      j++;
    }
    while (!syntax_error);
  }
  else
  { if (isalpha (tp[j]))
    { do
      { if (isalpha (tp[j])) sym_count++;
        else
        { syntax_error = 1;
          break;
        }
        j++;
      }
      while (tp[j] != 0);
      if (!syntax_error)
      { for (int k = 0;proto_table[k].proto_number != -1;k++)
        { if (strlen (proto_table[k].proto_text) == sym_count)
          { equal = 1;
            for (int l = 0;l < sym_count;l++)
            { equal &= (toupper (tp[j-sym_count+l]) == proto_table[k].proto_text[l]);
              if (!equal) break;
            }
            if (equal)
            { *value = proto_table[k].proto_number;
              break;
            }
          }
        }
      }
    }
    else syntax_error = 1;
  }
  return syntax_error;
}

static int IsGoodProtocol (int proto)
{ for (int j = 0;proto_table[j].proto_number != -1;j++)
  { if (proto == proto_table[j].proto_number) return 1;
  }
  return 0;
}

static int ParseUnit (const char *tu,char *value)
{ int j,syntax_error;

  j = 0;
  while (tu[j] != 0)
  { if (!isspace (tu[j])) break;
    j++;
  }
  syntax_error = 0;
  if (isalpha (tu[j]))
  { do
    { if (isalpha (tu[j]))
      { switch (toupper (tu[j]))
        { case 'B':
           *value = 1;
           break;
          case 'K':
           *value = 2;
           break;
          case 'M':
           *value = 3;
           break;
          default:
           syntax_error = 1;
           break;
        }
      }
      else
      { if (tu[j] == 0) break;
        if (!isspace (tu[j]))
        { syntax_error = 1;
          break;
        }
      }
      j++;
    }
    while (!syntax_error);
  }
  else
  { if (isdigit (tu[j]))
    { do
      { if (isdigit (tu[j]))
        { switch (tu[j])
          { case '1':
             *value = 1;
             break;
            case '2':
             *value = 2;
             break;
            case '3':
             *value = 3;
             break;
            default:
             syntax_error = 1;
             break;
          }
        }
        else
        { if (tu[j] == 0) break;
          if (!isspace (tu[j]))
          { syntax_error = 1;
            break;
          }
        }
        j++;
      }
      while (!syntax_error);
    }
    else syntax_error = 1;
  }
  return syntax_error;
}

static int ParseReportType (char const *trt,char *value)
{ int j,syntax_error;

  j = 0;
  while (trt[j] != 0)
  { if (!isspace (trt[j])) break;
    j++;
  }
  syntax_error = 0;
  do
  { if (isdigit (trt[j]))
    { switch (trt[j])
      { case '1':
         *value = 1;
         break;
        case '2':
         *value = 2;
         break;
        case '3':
         *value = 3;
         break;
        default:
         syntax_error = 1;
         break;
      }
    }
    else
    { if (trt[j] == 0) break;
      if (!isspace (trt[j]))
      { syntax_error = 1;
        break;
      }
    }
    j++;
  }
  while (!syntax_error);
  return syntax_error;
}

static int ParseClassFilter (char const *cft,char *value)
{ int j,syntax_error;

  j = 0;
  while (cft[j] != 0)
  { if (!isspace (cft[j])) break;
    j++;
  }
  syntax_error = 0;
  do
  { if (isdigit (cft[j]))
    { switch (cft[j])
      { case '1':
         *value = 0;
         break;
        case '2':
         *value = 1;
         break;
        case '3':
         *value = 2;
         break;
        case '4':
         *value = 3;
         break;
        default:
         syntax_error = 1;
         break;
      }
    }
    else
    { if (isalpha (cft[j]))
      { switch (cft[j])
        { case 'n':
           *value = 0;
           break;
          case 'i':
           *value = 1;
           break;
          case 'o':
           *value = 2;
           break;
          case 'p':
           *value = 3;
           break;
          default:
           syntax_error = 1;
           break;
        }
      }
      else
      { if (cft[j] == 0) break;
        if (!isspace (cft[j]))
        { syntax_error = 1;
          break;
        }
      }
    }
    j++;
  }
  while (!syntax_error);
  return syntax_error;
}

static int ParseWorkMode (char const *wmt,char *value)
{ int j,syntax_error;

  j = 0;
  while (wmt[j] != 0)
  { if (!isspace (wmt[j])) break;
    j++;
  }
  syntax_error = 0;
  do
  { if (isdigit (wmt[j]))
    { switch (wmt[j])
      { case '1':
         *value = 0;
         break;
        case '2':
         *value = 1;
         break;
        default:
         syntax_error = 1;
         break;
      }
    }
    else
    { if (isalpha (wmt[j]))
      { switch (wmt[j])
        { case 'r':
           *value = 0;
           break;
          case 'c':
           *value = 1;
           break;
          default:
           syntax_error = 1;
           break;
        }
      }
      else
      { if (wmt[j] == 0) break;
        if (!isspace (wmt[j]))
        { syntax_error = 1;
          break;
        }
      }
    }
    j++;
  }
  while (!syntax_error);
  return syntax_error;
}

static char *GetCmdLineOpt (char const *name)
{ int j,k,l,m;
  char ok;

  if (my_argc > 1)
  { for (j = my_argc - 1;j >= 1;j--)
    { k = strlen (my_argv[j]);
      if ((my_argv[j][0] == '-') && (k > 1))
      { l = 1;
        m = 0;
        while ((my_argv[j][l] != '=') && (my_argv[j][l] != 0))
        { l++;
          m++;
        }
        if (m == strlen (name))
        { l = 1;
          m = 0;
          ok = 1;
          while ((my_argv[j][l] != '=') && (my_argv[j][l] != 0) && (name[m] != 0))
          { ok &= (my_argv[j][l] == name[m]);
            if (!ok) break;
            l++;
            m++;
          }
          if (ok) return (strdup ((l == k - 1)?"":(char *)&(my_argv[j][l+1])));
        }
      }
    }
  }
  return NULL;
}

static bool GetCmdLineSwitch (char const *name)
{ if (my_argc > 1)
  { for (int j = my_argc - 1;j >= 1;j--)
    { if ((my_argv[j][0] == '-') &&
          (strlen (my_argv[j]) > 1) &&
          (strcmp (&(my_argv[j][1]),name) == 0)) return true;
    }
  }
  return false;
}

static void Chomp (char *data)
{ int l;

  if ((data != NULL) && (data[0] != 0))
  { l = strlen (data);
    if (data[l-1] == '\n')
    { if (data[l-2] == '\r') data[l-2] = 0;
      else data[l-1] = 0;
    }
  }
}

static char *Trim (const char *str)
{ int j,startpos,len;
  char *res;

  if (str != NULL)
  { j = strlen (str);
    if (j > 1)
    { j = 0;
      while (str[j] != 0)
      { if (!isspace (str[j])) break;
        j++;
      }
      startpos = j;
      j = strlen (str)-1;
      while (j > startpos)
      { if (!isspace (str[j])) break;
        j--;
      }
      len = j - startpos + 1;
      res = (char *)malloc (len + 1);
      memset (res,0,len + 1);
      strncpy (res,&(str[startpos]),len);
    }
    else res = strdup (str);
    return res;
  }
  return NULL;
}

static void workmode_prompt ()
{ printf (WorkModePromptMsg,DefaultWorkMode);
}

static bool workmode_process (char const *value)
{ char val;

  if (ParseWorkMode (value,&val) == 0)
  { workmode = val;
    return true;
  }
  else return false;
}

static void workmode_setdefault ()
{ ParseWorkMode (DefaultWorkMode,&workmode);
}

static void period_begin_prompt ()
{ printf (PeriodBeginPromptMsg);
}

static bool period_begin_datetime_process (char const *value)
{ int values[6];
  struct tm tmbuf;

  if ((ParseDateTime (value,values) == 0) && (IsGoodDateTime (values)))
  { memset (&tmbuf,0,sizeof (tmbuf));
    tmbuf.tm_sec = values[5];
    tmbuf.tm_min = values[4];
    tmbuf.tm_hour = values[3];
    tmbuf.tm_mday = values[0];
    tmbuf.tm_mon = values[1]-1;
    tmbuf.tm_year = values[2]-1900;
    tmbuf.tm_isdst = -1;
    period_begin = (int)mktime (&tmbuf);
    return true;
  }
  else return false;
}

static bool period_begin_timestamp_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodInteger (val)))
  { period_begin = val;
    return true;
  }
  else return false;
}

static void period_end_prompt ()
{ printf (PeriodEndPromptMsg);
}

static bool period_end_datetime_process (char const *value)
{ int values[6];
  struct tm tmbuf;

  if ((ParseDateTime (value,values) == 0) && (IsGoodDateTime (values)))
  { memset (&tmbuf,0,sizeof (tmbuf));
    tmbuf.tm_sec = values[5];
    tmbuf.tm_min = values[4];
    tmbuf.tm_hour = values[3];
    tmbuf.tm_mday = values[0];
    tmbuf.tm_mon = values[1]-1;
    tmbuf.tm_year = values[2]-1900;
    tmbuf.tm_isdst = -1;
    period_end = (int)mktime (&tmbuf);
    return true;
  }
  else return false;
}

static bool period_end_timestamp_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodInteger (val)))
  { period_end = val;
    return true;
  }
  else return false;
}

static void path_prompt ()
{ printf (DataFilePathPromptMsg,DefaultDataFilePath);
}

static bool path_process (char const *value)
{ dbpath = value;
  return true;
}

static void path_setdefault ()
{ dbpath = DefaultDataFilePath;
}

static void account_id_prompt ()
{ printf (AccountIdPromptMsg);
}

static bool account_id_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodInteger (val)))
  { account_id = val;
    return true;
  }
  else return false;
}

static void slink_id_prompt ()
{ printf (ServiceLinkIdPromptMsg);
}

static bool slink_id_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodInteger (val)))
  { slink_id = val;
    return true;
  }
  else return false;
}

static void class_filter_prompt ()
{ printf (ClassFilterPromptMsg,DefaultClassFilter);
}

static bool class_filter_process (char const *value)
{ char val;

  if (ParseClassFilter (value,&val) == 0)
  { class_filter = val;
    return true;
  }
  else return false;
}

static void class_filter_setdefault ()
{ class_filter = 0;
}

static void source_addr_prompt ()
{ printf (SrcIPAddressPromptMsg);
}

static bool source_addr_process (char const *value)
{ int values[4];

  if ((ParseIPAddress (value,values) == 0) && (IsGoodIPAddress (values)))
  { source_addr = (values[0] << 24) | (values[1] << 16) | (values[2] << 8) | values[3];
    return true;
  }
  else return false;
}

static void dest_addr_prompt ()
{ printf (DestIPAddressPromptMsg);
}

static bool dest_addr_process (char const *value)
{ int values[4];

  if ((ParseIPAddress (value,values) == 0) && (IsGoodIPAddress (values)))
  { dest_addr = (values[0] << 24) | (values[1] << 16) | (values[2] << 8) | values[3];
    return true;
  }
  else return false;
}

static void source_port_prompt ()
{ printf (SrcPortPromptMsg);
}

static bool source_port_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodShort (val)))
  { source_port = val;
    return true;
  }
  else return false;
}

static void dest_port_prompt ()
{ printf (DestPortPromptMsg);
}

static bool dest_port_process (char const *value)
{ int val;

  if ((ParseInteger (value,&val) == 0) && (IsGoodShort (val)))
  { dest_port = val;
    return true;
  }
  else return false;
}

static void protocol_prompt ()
{ printf (ProtocolPromptMsg);
}

static bool protocol_process (char const *value)
{ int val;

  if ((ParseProtocol (value,&val) == 0) && (IsGoodProtocol (val)))
  { proto = val;
    return true;
  }
  else return false;
}

static int protocol_skip ()
{ return (workmode == 0)?0:3;
}

static void report_type_prompt ()
{ printf (ReportTypePromptMsg,DefaultReportType);
}

static bool report_type_process (char const *value)
{ if (ParseReportType (value,&report_type) != 0) report_type = DefaultReportType;
  return true;
}

static void report_type_setdefault ()
{ report_type = DefaultReportType;
}

static int report_type_skip ()
{ return (report_type == 2)?0:1;
}

static void aggregation_step_prompt ()
{ printf (AggregationStepPromptMsg,DefaultAggregationStep);
}

static bool aggregation_step_process (char const *value)
{ int val;

  if (report_type == 2)
  { if ((ParseInteger (value,&val) == 0) && (IsGoodShort (val)))
    { agg_step = val;
      return true;
    }
    else return false;
  }
  else return true;
}

static void aggregation_step_setdefault ()
{ if (report_type == 2) ParseInteger (DefaultAggregationStep,&agg_step);
}

static void unit_prompt ()
{ printf (UnitPromptMsg,DefaultUnit);
}

static bool unit_process (char const *value)
{ return (ParseUnit (value,&unit) == 0);
}

static void unit_setdefault ()
{ ParseUnit (DefaultUnit,&unit);
}

static void outfile_prompt ()
{ switch (workmode)
  { case 0:
     printf (RepModeResultFilePromptMsg,DefaultRepModeResultFile);
     break;
    case 1:
     printf (CvtModeResultFilePromptMsg,DefaultCvtModeResultFile);
     break;
    default:
     break;
  }
}

static bool outfile_process (char const *value)
{ outfile_name = value;
  return true;
}

static void outfile_setdefault ()
{ switch (workmode)
  { case 0:
     outfile_name = DefaultRepModeResultFile;
     break;
    case 1:
     outfile_name = DefaultCvtModeResultFile;
     break;
    default:
     break;
  }
}

typedef struct
{ char *opt_long;
  char *opt_short;
  void (*prompt)();
  bool (*process)(char const *);
  void (*setdefault)();
  int (*skip)();
} param;

static param params[] =
{{"mode",NULL,workmode_prompt,workmode_process,workmode_setdefault,NULL},
 {"bp",NULL,period_begin_prompt,period_begin_datetime_process,NULL,NULL},
 {"ep",NULL,period_end_prompt,period_end_datetime_process,NULL,NULL},
 {"bt",NULL,NULL,period_begin_timestamp_process,NULL,NULL},
 {"et",NULL,NULL,period_end_timestamp_process,NULL,NULL},
 {"path",NULL,path_prompt,path_process,path_setdefault,NULL},
 {"a",NULL,account_id_prompt,account_id_process,NULL,NULL},
 {"s",NULL,slink_id_prompt,slink_id_process,NULL,NULL},
 {"cf",NULL,class_filter_prompt,class_filter_process,class_filter_setdefault,NULL},
 {"srcaddr","sa",source_addr_prompt,source_addr_process,NULL,NULL},
 {"dstaddr","da",dest_addr_prompt,dest_addr_process,NULL,NULL},
 {"srcport","sp",source_port_prompt,source_port_process,NULL,NULL},
 {"dstport","dp",dest_port_prompt,dest_port_process,NULL,NULL},
 {"proto","pr",protocol_prompt,protocol_process,NULL,protocol_skip},
 {"report","rep",report_type_prompt,report_type_process,report_type_setdefault,report_type_skip},
 {"aggstep","astp",aggregation_step_prompt,aggregation_step_process,aggregation_step_setdefault,NULL},
 {"unit","u",unit_prompt,unit_process,unit_setdefault,NULL},
 {"outfile","out",outfile_prompt,outfile_process,outfile_setdefault,NULL},
 {NULL,NULL,NULL,NULL,NULL,NULL}};

void LoadParameters (bool non_interactive)
{ int j;
  char *par, *tpar, *line;
  bool ok;

  if (!non_interactive) line = (char *)malloc (1024);
  for (j = 0;params[j].opt_long != NULL;j++)
  { par = GetCmdLineOpt (params[j].opt_long);
    if ((par == NULL) && (params[j].opt_short != NULL)) par = GetCmdLineOpt (params[j].opt_short);
    if (par != NULL)
    { tpar = Trim (par);
      free (par);
      if ((tpar[0] != 0) && (params[j].process != NULL)) params[j].process (tpar);
      if ((tpar[0] == 0) && (params[j].setdefault != NULL)) params[j].setdefault ();
      free (tpar);
    }
    else
    { if ((!non_interactive) && (params[j].prompt != NULL))
      { if (stopped) break;
        do
        { line[0] = 0;
          ok = true;
          params[j].prompt ();
          fgets (line,1023,stdin);
          Chomp (line);
          tpar = Trim (line);
          if ((tpar[0] != 0) && (params[j].process != NULL))
          { ok = params[j].process (tpar);
            free (tpar);
          }
          else
          { free (tpar);
            if (params[j].setdefault != NULL) params[j].setdefault ();
            break;
          }
          if (!ok) printf (UserDataErrorMsg);
        }
        while (!ok);
      }
      else
      { if (params[j].setdefault != NULL) params[j].setdefault ();
      }
      if (params[j].skip != NULL) j += params[j].skip ();
    }
  }
  if (!non_interactive) free (line);
}

void LoadCmdLineFlags ()
{ quiet = GetCmdLineSwitch ("q");
  noi = GetCmdLineSwitch ("noi");
  help_me = GetCmdLineSwitch ("h");
  to_stdout = GetCmdLineSwitch ("stdout");
}

static int ParseIntArray (char const *text,std::vector<int>& values)
{ int j,digit_buf,digits_count,syntax_error,range_start;
  char empty_buf,range_mode;

  j = 0;
  while (isspace (text[j])) j++;
  while (text[j] != '=') j++;
  j++;
  if (text[j] == 0) return 0;
  while (isspace (text[j])) j++;
  syntax_error = 0;
  empty_buf = 1;
  range_mode = 0;
  range_start = 0;
  digit_buf = 0;
  digits_count = 0;
  do
  { if (isdigit (text[j]))
    { empty_buf = 0;
      if ((j != 0) && (isdigit (text[j-1]))) digit_buf *= 10;
      digit_buf += (text[j] - '0');
      digits_count++;
      if (digits_count > 10)
      { syntax_error = 1;
        break;
      }
    }
    else
    { if ((text[j] == ',') || (text[j] == 0) && (!empty_buf))
      { if (!range_mode) values.insert (values.end (),digit_buf);
        else
        { if (range_start < digit_buf)
           for (int k = range_start;k <= digit_buf;k++) values.insert (values.end (),k);
          else
           for (int k = digit_buf;k >= range_start;k--) values.insert (values.end (),k);
        }
        empty_buf = 1;
        digit_buf = 0;
        digits_count = 0;
        if (text[j] == 0) break;
      }
      else
      { if (text[j] == '-')
        { range_mode = 1;
          range_start = digit_buf;
          empty_buf = 1;
          digit_buf = 0;
          digits_count = 0;
        }
        else
        { if (text[j] == 0) break;
          if (!isspace (text[j]))
          { syntax_error = 1;
            break;
          }
        }
      }
    }
    j++;
  }
  while (!syntax_error);
  return syntax_error;
}

static int ParseString (char const *text,std::string& str)
{ int j;
  bool quoted;

  j = 0;
  while (isspace (text[j])) j++;
  while (text[j] != '=') j++;
  j++;
  if (text[j] == 0) return 0;
  str.clear ();
  quoted = false;
  while (isspace (text[j])) j++;
  if (text[j] == '"')
  { quoted = true;
    j++;
  }
  do
  { if ((quoted) && (text[j] == '"')) break;
    if ((!quoted) && (isspace (text[j]))) break;
    str.insert (str.end (),text[j]);
    j++;
  }
  while (text[j] != 0);
  return 0;
}

static int incoming_classes_parse (char const *text)
{ incoming_classes.erase (incoming_classes.begin (),incoming_classes.end ());
  return ParseIntArray (text,incoming_classes);
}

static int outgoing_classes_parse (char const *text)
{ outgoing_classes.erase (outgoing_classes.begin (),outgoing_classes.end ());
  return ParseIntArray (text,outgoing_classes);
}

static int paid_classes_parse (char const *text)
{ paid_classes.erase (paid_classes.begin (),paid_classes.end ());
  return ParseIntArray (text,paid_classes);
}

static int temp_path_parse (char const *text)
{ temp_path.clear ();
  return ParseString (text,temp_path);
}

typedef struct
{ char *name;
  int (*parser)(char const *);
} cfgfile_param;

static cfgfile_param config_params[] =
{{"incoming_classes",incoming_classes_parse},
 {"outgoing_classes",outgoing_classes_parse},
 {"paid_classes",paid_classes_parse},
 {"temp_path",temp_path_parse},
 {NULL,NULL}};

void LoadParametersFromConfigFile ()
{ FILE *cf;
  char buffer[512];
  char *line;
  int j;

#ifdef WIN32
  j = strlen (my_argv[0]) - 1;
  while ((my_argv[0][j] != PathDivider) && (j > 0)) j--;
  memset (&buffer,0,512);
  if (j > 0) strncpy (&(buffer[0]),my_argv[0],j+1);
  else
  { buffer[0] = '.';
    buffer[1] = PathDivider;
    buffer[2] = 0;
  }
  strcat (&(buffer[0]),"utmdrg.cnf");
#else
  strcpy (&(buffer[0]),"/etc/utmdrg.cnf");
#endif
  cf = fopen (&(buffer[0]),"r");
  if (cf != NULL)
  { while (!feof (cf))
    { buffer[0] = 0;
      fgets (&(buffer[0]),511,cf);
      Chomp (&(buffer[0]));
      line = Trim (&(buffer[0]));
      if (line[0] == 0) free (line);
      else
      { if (line[0] != '#')
        { j = 0;
          while (config_params[j].name != NULL)
          { if (strncmp (line,config_params[j].name,strlen (config_params[j].name)) == 0)
             config_params[j].parser (line);
            j++;
          }
        }
        free (line);
      }
    }
    fclose (cf);
  }
}
