#ifndef _params_h
#define _params_h

typedef struct
{ int proto_number;
  char *proto_text;
} proto_entry;

class IntParameter
{ public:
   IntParameter ()
   { empty = true;
     val = 0;
   }
   IntParameter (IntParameter& another)
   { empty = another.IsEmpty ();
     val = another.Value ();
   }
   ~IntParameter ()
   {}
   int Value ()
   { return (empty)?0:val;
   }
   bool IsEmpty ()
   { return empty;
   }
   void SetValue (int value)
   { empty = false;
     val = value;
   }
   void Clear ()
   { empty = true;
     val = 0;
   }
   int operator = (int value)
   { SetValue (value);
     return value;
   }
  private:
   bool empty;
   int val;
};

extern proto_entry proto_table[];
extern FILE *outfile;
extern IntParameter period_begin;
extern IntParameter period_end;
extern IntParameter account_id;
extern IntParameter slink_id;
extern IntParameter source_addr;
extern IntParameter dest_addr;
extern IntParameter source_port;
extern IntParameter dest_port;
extern IntParameter proto;
extern int my_argc;
extern char **my_argv;
extern bool quiet;
extern bool noi;
extern bool help_me;
extern std::string temp_path;
extern std::string dbpath;
extern std::string outfile_name;
extern char class_filter;
extern char workmode;
extern std::vector<int> incoming_classes;
extern std::vector<int> outgoing_classes;
extern std::vector<int> paid_classes;
extern bool to_stdout;
extern char unit;
extern char report_type;
extern int agg_step;

void LoadCmdLineFlags ();
void LoadParametersFromConfigFile ();
void LoadParameters (bool non_interactive);

#endif
