#include <windows.h>
#include <stdio.h>
#include "globals.h"
#include "params.h"
#include "err_rep.h"
#include "UTMDRGW.rh"

static char *param_error_base_msg;
static char *error_hdr;
static bool initialized;
static FILE *logf;

void InitErrorReport ()
{ if (!initialized)
  { param_error_base_msg = new char[256];
    error_hdr = new char[256];
    LoadString (inst,IDS_ERRMSG_PARAM,(LPSTR)param_error_base_msg,256);
    LoadString (inst,IDS_ERRMSG_HDR,(LPSTR)error_hdr,256);
    if (quiet) logf = fopen ("utmdrg.log","wt");
    initialized = true;
  }
}

void ExitErrorReport ()
{ if (initialized)
  { delete [] param_error_base_msg;
    delete [] error_hdr;
    if ((quiet) && (logf != NULL))
    { fclose (logf);
      logf = NULL;
    }
    initialized = false;
  }
}

void ParamErrorBox (int param_name_id)
{ char *param_name;
  char *msgbuf;

  if (initialized)
  { param_name = new char[256];
    msgbuf = new char[512];
    LoadString (inst,param_name_id,(LPSTR)param_name,256);
    sprintf (msgbuf,param_error_base_msg,param_name);
    if (quiet) fputs (msgbuf,logf);
    else
    { EnterCriticalSection (&mainwnd_cs);
      if (mainwnd != 0) MessageBox (mainwnd,msgbuf,error_hdr,MB_OK | MB_ICONERROR);
      LeaveCriticalSection (&mainwnd_cs);
    }
    delete [] msgbuf;
    delete [] param_name;
  }
}

void ErrorBox (int errmsg_id)
{ char *msgbuf;

  if (initialized)
  { msgbuf = new char[512];
    LoadString (inst,errmsg_id,(LPSTR)msgbuf,512);
    if (quiet) fputs (msgbuf,logf);
    else
    { EnterCriticalSection (&mainwnd_cs);
      if (mainwnd != 0) MessageBox (mainwnd,msgbuf,error_hdr,MB_OK | MB_ICONERROR);
      LeaveCriticalSection (&mainwnd_cs);
    }
    delete [] msgbuf;
  }
}
