#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>
#include <stdlib.h>
#include <objbase.h>
#include <shellapi.h>
#include <shlwapi.h>
#include <shlobj.h>
#include <process.h>
#include <vector>
#include <string>
#include "globals.h"
#include "params.h"
#include "wkthread.h"
#include "err_rep.h"
#include "utmdrgw.rh"

#define WM_INITIALIZE WM_USER+1

static int showcmd;
static char *progress_caption_str;
static char *progress_caption_buffer;
static char *std_caption_buffer;

static BOOL HWM_INITIALIZE (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ HWND swnd;
  HMENU hSysMenu;
  char tbuf[256];
  int j;

  hSysMenu = GetSystemMenu (wnd,FALSE);
  DeleteMenu (hSysMenu,SC_MAXIMIZE,MF_BYCOMMAND);
  DeleteMenu (hSysMenu,SC_SIZE,MF_BYCOMMAND);
  DrawMenuBar (wnd);
  SendMessage (wnd,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon (inst,MAKEINTRESOURCE (IDI_MAIN_BIG)));
  SendMessage (wnd,WM_SETICON,ICON_SMALL,(LPARAM)LoadIcon (inst,MAKEINTRESOURCE (IDI_MAIN_SMALL)));
  SendDlgItemMessage (wnd,IDC_PERIOD_BEGIN_TEXT,EM_SETLIMITTEXT,24,0);
  SendDlgItemMessage (wnd,IDC_PERIOD_END_TEXT,EM_SETLIMITTEXT,24,0);
  SendDlgItemMessage (wnd,IDC_ACCOUNT_ID_TEXT,EM_SETLIMITTEXT,10,0);
  SendDlgItemMessage (wnd,IDC_SLINK_ID_TEXT,EM_SETLIMITTEXT,10,0);
  SendDlgItemMessage (wnd,IDC_SOURCE_ADDR_TEXT,EM_SETLIMITTEXT,15,0);
  SendDlgItemMessage (wnd,IDC_DEST_ADDR_TEXT,EM_SETLIMITTEXT,15,0);
  SendDlgItemMessage (wnd,IDC_SOURCE_PORT_TEXT,EM_SETLIMITTEXT,5,0);
  SendDlgItemMessage (wnd,IDC_DEST_PORT_TEXT,EM_SETLIMITTEXT,5,0);
  SendDlgItemMessage (wnd,IDC_PROTO_TEXT,EM_SETLIMITTEXT,5,0);
  swnd = GetDlgItem (wnd,IDC_TRAF_TYPE_COMBOBOX);
  SendMessage (swnd,CB_RESETCONTENT,0,0);
  for (j = 0;j < 3;j++)
  { LoadString (inst,IDS_TRAF_TYPE_BASE+j,(CHAR *)&tbuf,255);
    SendMessage (swnd,CB_ADDSTRING,0,(LPARAM)(LPCSTR)&tbuf);
  }
  SendMessage (swnd,CB_SETCURSEL,0,0);
  swnd = GetDlgItem (wnd,IDC_OUT_FORMAT_COMBOBOX);
  SendMessage (swnd,CB_RESETCONTENT,0,0);
  for (j = 0;j < 2;j++)
  { LoadString (inst,IDS_OUT_FORMAT_BASE+j,(CHAR *)&tbuf,255);
    SendMessage (swnd,CB_ADDSTRING,0,(LPARAM)(LPCSTR)&tbuf);
  }
  SendMessage (swnd,CB_SETCURSEL,0,0);
  swnd = GetDlgItem (wnd,IDC_REPORT_TYPE_COMBOBOX);
  SendMessage (swnd,CB_RESETCONTENT,0,0);
  for (j = 0;j < 3;j++)
  { LoadString (inst,IDS_REPORT_TYPE_BASE+j,(CHAR *)&tbuf,255);
    SendMessage (swnd,CB_ADDSTRING,0,(LPARAM)(LPCSTR)&tbuf);
  }
  SendMessage (swnd,CB_SETCURSEL,0,0);
  swnd = GetDlgItem (wnd,IDC_TRAF_UNIT_COMBOBOX);
  SendMessage (swnd,CB_RESETCONTENT,0,0);
  for (j = 0;j < 3;j++)
  { LoadString (inst,IDS_TRAF_UNIT_BASE+j,(CHAR *)&tbuf,255);
    SendMessage (swnd,CB_ADDSTRING,0,(LPARAM)(LPCSTR)&tbuf);
  }
  SendMessage (swnd,CB_SETCURSEL,2,0);
  swnd = GetDlgItem (wnd,IDC_AGGSTEP_TEXT);
  SendMessage (swnd,EM_SETLIMITTEXT,3,0);
  SetWindowText (swnd,(LPCTSTR)DefaultAggregationStep);
  swnd = GetDlgItem (wnd,IDC_OUTFILE_TEXT);
  SendMessage (swnd,EM_SETLIMITTEXT,MAX_PATH,0);
  SetWindowText (swnd,(LPCTSTR)DefaultRepModeResultFile);
  swnd = GetDlgItem (wnd,IDC_PATH_TO_DATA_TEXT);
  SendMessage (swnd,EM_SETLIMITTEXT,MAX_PATH,0);
  SetWindowText (swnd,(LPCTSTR)DefaultDataFilePath);
  return TRUE;
}

static BOOL HWM_CLOSE (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ DestroyWindow (wnd);
  return TRUE;
}

static BOOL HWM_DESTROY (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ EnterCriticalSection (&mainwnd_cs);
  mainwnd = 0;
  LeaveCriticalSection (&mainwnd_cs);
  if (wkthread != 0)
  { stopped = TRUE;
    WaitForSingleObject (wkthread,INFINITE);
    CloseHandle (wkthread);
  }
  PostQuitMessage (0);
  return TRUE;
}

static BOOL BtnClick_Cancel (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ PostMessage (wnd,WM_CLOSE,0,0);
  return TRUE;
}

static BOOL BtnClick_FilterCheckBox (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ int checked;

  checked = IsDlgButtonChecked (wnd,LOWORD (wp));
  CheckDlgButton (wnd,LOWORD (wp),checked?BST_UNCHECKED:BST_CHECKED);
  EnableWindow (GetDlgItem (wnd,wp+1),checked?FALSE:TRUE);
  return TRUE;
}

static BOOL BtnClick_SelectOutputFile (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ OPENFILENAME ofn;
  char buffer[MAX_PATH];

  memset (buffer,0,sizeof (buffer));
  memset (&ofn,0,sizeof (ofn));
  ofn.lStructSize = sizeof (ofn);
  ofn.hwndOwner = wnd;
  ofn.hInstance = inst;
  ofn.lpstrFile = (char *)&buffer;
  ofn.nMaxFile = sizeof (buffer);
  if (GetSaveFileName (&ofn)) SetWindowText (GetDlgItem (wnd,IDC_OUTFILE_TEXT),(LPCTSTR)&buffer);
  return TRUE;
}

static BOOL BtnClick_ViewOutput (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ int checked;

  checked = IsDlgButtonChecked (wnd,IDC_VIEWOUTPUT_CHECKBOX);
  CheckDlgButton (wnd,IDC_VIEWOUTPUT_CHECKBOX,checked?BST_UNCHECKED:BST_CHECKED);
  return TRUE;
}

static BOOL BtnClick_SelectDataFilePath (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ BROWSEINFO bi;
  char display_name[MAX_PATH];
  char selected_path[MAX_PATH];
  LPITEMIDLIST idl;

  memset (&display_name,0,sizeof (display_name));
  memset (&bi,0,sizeof (bi));
  bi.hwndOwner = wnd;
  bi.pszDisplayName = (LPTSTR)&display_name;
  bi.ulFlags = BIF_RETURNONLYFSDIRS;
  idl = SHBrowseForFolder (&bi);
  if (idl != NULL)
  { if (SHGetPathFromIDList (idl,(LPTSTR)&selected_path)) SetWindowText (GetDlgItem (wnd,IDC_PATH_TO_DATA_TEXT),(LPCTSTR)&selected_path);
    CoTaskMemFree (idl);
  }
  return TRUE;
}

static BOOL CBSelChange_OutFormat (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ switch (SendDlgItemMessage (wnd,IDC_OUT_FORMAT_COMBOBOX,CB_GETCURSEL,0,0))
  { case 0:
     EnableWindow (GetDlgItem (wnd,IDC_REPORT_TYPE_COMBOBOX),TRUE);
     EnableWindow (GetDlgItem (wnd,IDC_TRAF_UNIT_COMBOBOX),TRUE);
     EnableWindow (GetDlgItem (wnd,IDC_AGGSTEP_TEXT),TRUE);
     EnableWindow (GetDlgItem (wnd,IDC_VIEWOUTPUT_CHECKBOX),TRUE);
     break;
    case 1:
     EnableWindow (GetDlgItem (wnd,IDC_REPORT_TYPE_COMBOBOX),FALSE);
     EnableWindow (GetDlgItem (wnd,IDC_TRAF_UNIT_COMBOBOX),FALSE);
     EnableWindow (GetDlgItem (wnd,IDC_AGGSTEP_TEXT),FALSE);
     EnableWindow (GetDlgItem (wnd,IDC_VIEWOUTPUT_CHECKBOX),FALSE);
     break;
    default: break;
  }
  return TRUE;
}

static BOOL CBSelChange_ReportType (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ switch (SendDlgItemMessage (wnd,IDC_REPORT_TYPE_COMBOBOX,CB_GETCURSEL,0,0))
  { case 0:
    case 2:
     EnableWindow (GetDlgItem (wnd,IDC_AGGSTEP_TEXT),FALSE);
     break;
    case 1:
     EnableWindow (GetDlgItem (wnd,IDC_AGGSTEP_TEXT),TRUE);
     break;
    default: break;
  }
  return TRUE;
}

static BOOL BtnClick_StartWork (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ unsigned int tid;

  if (wkthread == 0)
  { EnableWindow (GetDlgItem (wnd,IDC_START_WORK_BUTTON),FALSE);
    stopped = false;
    wkthread = (HANDLE)_beginthreadex (NULL,0,WorkThreadProc,NULL,0,&tid);
    GetWindowText (wnd,(LPSTR)std_caption_buffer,256);
  }
  return TRUE;
}

static BOOL BtnClick_CancelWork (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ if (!stopped) stopped = TRUE;
  return TRUE;
}

static BOOL HWM_COMMAND (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ switch (HIWORD (wp))
  { case BN_CLICKED:
     switch (LOWORD (wp))
     { case IDCANCEL:
        return BtnClick_Cancel (wnd,msg,wp,lp);
       case IDC_PERIOD_BEGIN_CHECKBOX:
       case IDC_PERIOD_END_CHECKBOX:
       case IDC_ACCOUNT_ID_CHECKBOX:
       case IDC_SLINK_ID_CHECKBOX:
       case IDC_SOURCE_ADDR_CHECKBOX:
       case IDC_DEST_ADDR_CHECKBOX:
       case IDC_SOURCE_PORT_CHECKBOX:
       case IDC_DEST_PORT_CHECKBOX:
       case IDC_PROTO_CHECKBOX:
       case IDC_TRAF_TYPE_CHECKBOX:
        return BtnClick_FilterCheckBox (wnd,msg,wp,lp);
       case IDC_OUTFILE_SEL_BUTTON:
        return BtnClick_SelectOutputFile (wnd,msg,wp,lp);
       case IDC_VIEWOUTPUT_CHECKBOX:
        return BtnClick_ViewOutput (wnd,msg,wp,lp);
       case IDC_PATH_TO_DATA_SEL_BUTTON:
        return BtnClick_SelectDataFilePath (wnd,msg,wp,lp);
       case IDC_START_WORK_BUTTON:
        return BtnClick_StartWork (wnd,msg,wp,lp);
       case IDC_CANCEL_WORK_BUTTON:
        return BtnClick_CancelWork (wnd,msg,wp,lp);
       default: return FALSE;
     }
    case CBN_SELCHANGE:
     switch (LOWORD (wp))
     { case IDC_OUT_FORMAT_COMBOBOX:
        return CBSelChange_OutFormat (wnd,msg,wp,lp);
       case IDC_REPORT_TYPE_COMBOBOX:
        return CBSelChange_ReportType (wnd,msg,wp,lp);
       default: return FALSE;
     }
    default: return FALSE;
  }
}

static BOOL HWM_THREAD_END (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ if (wkthread != 0)
  { WaitForSingleObject (wkthread,INFINITE);
    CloseHandle (wkthread);
    wkthread = 0;
    EnableWindow (GetDlgItem (wnd,IDC_START_WORK_BUTTON),TRUE);
    if ((!stopped) &&
        (IsWindowEnabled (GetDlgItem (wnd,IDC_VIEWOUTPUT_CHECKBOX))) &&
        (IsDlgButtonChecked (wnd,IDC_VIEWOUTPUT_CHECKBOX)))
    { if (PathFileExists (outfile_name.c_str ()))
       ShellExecute (0,"open",outfile_name.c_str (),NULL,"",SW_SHOW);
    }
    if (noi)
    { if (!stopped) PostMessage (wnd,WM_CLOSE,0,0);
      else if (!quiet) noi = FALSE;
    }
  }
  return TRUE;
}

static BOOL HWM_INITPROGRESS (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ HWND pb;

  pb = GetDlgItem (wnd,IDC_PROGRESS_BAR);
  SendMessage (pb,PBM_SETRANGE,0,MAKELPARAM (0,100));
  SendMessage (pb,PBM_SETSTEP,1,0);
  SendMessage (pb,PBM_SETPOS,0,0);
  sprintf (progress_caption_buffer,progress_caption_str,0);
  return TRUE;
}

static BOOL HWM_UPDATEPROGRESS (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ SendDlgItemMessage (wnd,IDC_PROGRESS_BAR,PBM_SETPOS,wp,lp);
  if ((wp >= 0) && (wp <= 100))
  { sprintf (progress_caption_buffer,progress_caption_str,wp);
    if (IsIconic (wnd)) SetWindowText (wnd,(LPSTR)progress_caption_buffer);
  }
  return TRUE;
}

static BOOL HWM_CLEARPROGRESS (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ SendDlgItemMessage (wnd,IDC_PROGRESS_BAR,PBM_SETPOS,0,0);
  if (IsIconic (wnd)) SetWindowText (wnd,(LPSTR)std_caption_buffer);
}

static BOOL HWM_SIZE (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ if (wkthread != 0)
  { switch (wp)
    { case SIZE_MINIMIZED:
       SetWindowText (wnd,(LPSTR)progress_caption_buffer);
       break;
      case SIZE_RESTORED:
       SetWindowText (wnd,(LPSTR)std_caption_buffer);
       break;
    }
  }
  return TRUE;
}

BOOL CALLBACK DlgProc (HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
{ switch (msg)
  { case WM_INITIALIZE:
     return HWM_INITIALIZE (wnd,msg,wp,lp);
    case WM_CLOSE:
     return HWM_CLOSE (wnd,msg,wp,lp);
    case WM_COMMAND:
     return HWM_COMMAND (wnd,msg,wp,lp);
    case WM_DESTROY:
     return HWM_DESTROY (wnd,msg,wp,lp);
    case WM_THREAD_END:
     return HWM_THREAD_END (wnd,msg,wp,lp);
    case WM_INITPROGRESS:
     return HWM_INITPROGRESS (wnd,msg,wp,lp);
    case WM_UPDATEPROGRESS:
     return HWM_UPDATEPROGRESS (wnd,msg,wp,lp);
    case WM_CLEARPROGRESS:
     return HWM_CLEARPROGRESS (wnd,msg,wp,lp);
    case WM_SIZE:
     return HWM_SIZE (wnd,msg,wp,lp);
    default: return FALSE;
  }
}

static void App_Init ()
{ INITCOMMONCONTROLSEX iccx;

  my_argc = _argc;
  my_argv = _argv;
  memset (&iccx,0,sizeof (iccx));
  iccx.dwSize = sizeof (iccx);
  iccx.dwICC = ICC_PROGRESS_CLASS;
  InitCommonControlsEx (&iccx);
  CoInitializeEx (NULL,COINIT_APARTMENTTHREADED);
  LoadCmdLineFlags ();
  InitErrorReport ();
  progress_caption_str = new char[256];
  progress_caption_buffer = new char[256];
  std_caption_buffer = new char[256];
  LoadString (inst,IDS_PROGRESS_CAPTION,(LPSTR)progress_caption_str,256);
  InitializeCriticalSection (&mainwnd_cs);
}

static void App_Exit ()
{ ExitErrorReport ();
  delete [] std_caption_buffer;
  delete [] progress_caption_buffer;
  delete [] progress_caption_str;
  DeleteCriticalSection (&mainwnd_cs);
}

static HWND App_CreateMainWindow ()
{ HWND wnd;

  wnd = CreateDialogParam (inst,MAKEINTRESOURCE (IDD_MAIN),0,DlgProc,0);
  if (wnd == 0) return 0;
  SendMessage (wnd,WM_INITIALIZE,0,0);
  if (!quiet)
  { ShowWindow (wnd,showcmd);
    UpdateWindow (wnd);
  }
  return wnd;
}

static int App_MainMessageLoop ()
{ MSG m;

  while (GetMessage (&m,NULL,0,0))
  { if (!IsDialogMessage (mainwnd,&m))
    { TranslateMessage (&m);
      DispatchMessage (&m);
    }
  }
  return m.wParam;
}

int WINAPI WinMain (HINSTANCE hThisInst,
                    HINSTANCE hPrevInst,
                    LPSTR lpszCmdLine,
                    int nCmdShow)
{ int exitcode;

  inst = hThisInst;
  showcmd = nCmdShow;
  App_Init ();
  mainwnd = App_CreateMainWindow ();
  if (mainwnd != 0)
  { LoadParametersToWindow ();
    if (noi) PostMessage (mainwnd,WM_COMMAND,MAKELONG (IDC_START_WORK_BUTTON,BN_CLICKED),0);
    exitcode = App_MainMessageLoop ();
  }
  App_Exit ();
  return exitcode;
}
